(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('svelte/internal'), require('jsbarcode')) :
    typeof define === 'function' && define.amd ? define(['svelte/internal', 'jsbarcode'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.Barcode = factory(global.internal, global.JsBarcode));
}(this, (function (internal, JsBarcode) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var JsBarcode__default = /*#__PURE__*/_interopDefaultLegacy(JsBarcode);

    let current_component;
    function get_current_component() {
        throw new Error('Function called outside component initialization');
    }
    function onMount(fn) {
        get_current_component().$$.on_mount.push(fn);
    }

    /* src/Barcode.svelte generated by Svelte v3.35.0 */

    function create_else_block(ctx) {
    	let svg;

    	return {
    		c() {
    			svg = internal.svg_element("svg");
    		},
    		m(target, anchor) {
    			internal.insert(target, svg, anchor);
    			/*svg_binding*/ ctx[24](svg);
    		},
    		p: internal.noop,
    		d(detaching) {
    			if (detaching) internal.detach(svg);
    			/*svg_binding*/ ctx[24](null);
    		}
    	};
    }

    // (57:34) 
    function create_if_block_1(ctx) {
    	let canvas;

    	return {
    		c() {
    			canvas = internal.element("canvas");
    		},
    		m(target, anchor) {
    			internal.insert(target, canvas, anchor);
    			/*canvas_binding*/ ctx[23](canvas);
    		},
    		p: internal.noop,
    		d(detaching) {
    			if (detaching) internal.detach(canvas);
    			/*canvas_binding*/ ctx[23](null);
    		}
    	};
    }

    // (55:0) {#if elementTag === 'img'}
    function create_if_block(ctx) {
    	let img;

    	return {
    		c() {
    			img = internal.element("img");
    			internal.attr(img, "alt", "");
    		},
    		m(target, anchor) {
    			internal.insert(target, img, anchor);
    			/*img_binding*/ ctx[22](img);
    		},
    		p: internal.noop,
    		d(detaching) {
    			if (detaching) internal.detach(img);
    			/*img_binding*/ ctx[22](null);
    		}
    	};
    }

    function create_fragment(ctx) {
    	let if_block_anchor;

    	function select_block_type(ctx, dirty) {
    		if (/*elementTag*/ ctx[0] === "img") return create_if_block;
    		if (/*elementTag*/ ctx[0] === "canvas") return create_if_block_1;
    		return create_else_block;
    	}

    	let current_block_type = select_block_type(ctx);
    	let if_block = current_block_type(ctx);

    	return {
    		c() {
    			if_block.c();
    			if_block_anchor = internal.empty();
    		},
    		m(target, anchor) {
    			if_block.m(target, anchor);
    			internal.insert(target, if_block_anchor, anchor);
    		},
    		p(ctx, [dirty]) {
    			if (current_block_type === (current_block_type = select_block_type(ctx)) && if_block) {
    				if_block.p(ctx, dirty);
    			} else {
    				if_block.d(1);
    				if_block = current_block_type(ctx);

    				if (if_block) {
    					if_block.c();
    					if_block.m(if_block_anchor.parentNode, if_block_anchor);
    				}
    			}
    		},
    		i: internal.noop,
    		o: internal.noop,
    		d(detaching) {
    			if_block.d(detaching);
    			if (detaching) internal.detach(if_block_anchor);
    		}
    	};
    }

    function instance($$self, $$props, $$invalidate) {
    	let barcode;
    	let { value } = $$props;
    	let { elementTag = "img" } = $$props;
    	let { format = "CODE128" } = $$props;
    	let { width = 2 } = $$props;
    	let { height = 100 } = $$props;
    	let { displayValue = true } = $$props;
    	let { text = undefined } = $$props;
    	let { fontOptions = "" } = $$props;
    	let { font = "monospace" } = $$props;
    	let { textAlign = "center" } = $$props;
    	let { textPosition = "bottom" } = $$props;
    	let { textMargin = 2 } = $$props;
    	let { fontSize = 20 } = $$props;
    	let { background = "#ffffff" } = $$props;
    	let { lineColor = "#000000" } = $$props;
    	let { margin = 10 } = $$props;
    	let { marginTop = undefined } = $$props;
    	let { marginBottom = undefined } = $$props;
    	let { marginLeft = undefined } = $$props;
    	let { marginRight = undefined } = $$props;
    	let { flat = false } = $$props;

    	const options = {
    		format,
    		width,
    		height,
    		displayValue,
    		text,
    		fontOptions,
    		font,
    		textAlign,
    		textPosition,
    		textMargin,
    		fontSize,
    		background,
    		lineColor,
    		margin,
    		marginTop,
    		marginBottom,
    		marginLeft,
    		marginRight,
    		flat
    	};

    	onMount(() => {
    		JsBarcode__default['default'](barcode, value, options);
    	});

    	function img_binding($$value) {
    		internal.binding_callbacks[$$value ? "unshift" : "push"](() => {
    			barcode = $$value;
    			$$invalidate(1, barcode);
    		});
    	}

    	function canvas_binding($$value) {
    		internal.binding_callbacks[$$value ? "unshift" : "push"](() => {
    			barcode = $$value;
    			$$invalidate(1, barcode);
    		});
    	}

    	function svg_binding($$value) {
    		internal.binding_callbacks[$$value ? "unshift" : "push"](() => {
    			barcode = $$value;
    			$$invalidate(1, barcode);
    		});
    	}

    	$$self.$$set = $$props => {
    		if ("value" in $$props) $$invalidate(2, value = $$props.value);
    		if ("elementTag" in $$props) $$invalidate(0, elementTag = $$props.elementTag);
    		if ("format" in $$props) $$invalidate(3, format = $$props.format);
    		if ("width" in $$props) $$invalidate(4, width = $$props.width);
    		if ("height" in $$props) $$invalidate(5, height = $$props.height);
    		if ("displayValue" in $$props) $$invalidate(6, displayValue = $$props.displayValue);
    		if ("text" in $$props) $$invalidate(7, text = $$props.text);
    		if ("fontOptions" in $$props) $$invalidate(8, fontOptions = $$props.fontOptions);
    		if ("font" in $$props) $$invalidate(9, font = $$props.font);
    		if ("textAlign" in $$props) $$invalidate(10, textAlign = $$props.textAlign);
    		if ("textPosition" in $$props) $$invalidate(11, textPosition = $$props.textPosition);
    		if ("textMargin" in $$props) $$invalidate(12, textMargin = $$props.textMargin);
    		if ("fontSize" in $$props) $$invalidate(13, fontSize = $$props.fontSize);
    		if ("background" in $$props) $$invalidate(14, background = $$props.background);
    		if ("lineColor" in $$props) $$invalidate(15, lineColor = $$props.lineColor);
    		if ("margin" in $$props) $$invalidate(16, margin = $$props.margin);
    		if ("marginTop" in $$props) $$invalidate(17, marginTop = $$props.marginTop);
    		if ("marginBottom" in $$props) $$invalidate(18, marginBottom = $$props.marginBottom);
    		if ("marginLeft" in $$props) $$invalidate(19, marginLeft = $$props.marginLeft);
    		if ("marginRight" in $$props) $$invalidate(20, marginRight = $$props.marginRight);
    		if ("flat" in $$props) $$invalidate(21, flat = $$props.flat);
    	};

    	return [
    		elementTag,
    		barcode,
    		value,
    		format,
    		width,
    		height,
    		displayValue,
    		text,
    		fontOptions,
    		font,
    		textAlign,
    		textPosition,
    		textMargin,
    		fontSize,
    		background,
    		lineColor,
    		margin,
    		marginTop,
    		marginBottom,
    		marginLeft,
    		marginRight,
    		flat,
    		img_binding,
    		canvas_binding,
    		svg_binding
    	];
    }

    class Barcode extends internal.SvelteComponent {
    	constructor(options) {
    		super();

    		internal.init(this, options, instance, create_fragment, internal.safe_not_equal, {
    			value: 2,
    			elementTag: 0,
    			format: 3,
    			width: 4,
    			height: 5,
    			displayValue: 6,
    			text: 7,
    			fontOptions: 8,
    			font: 9,
    			textAlign: 10,
    			textPosition: 11,
    			textMargin: 12,
    			fontSize: 13,
    			background: 14,
    			lineColor: 15,
    			margin: 16,
    			marginTop: 17,
    			marginBottom: 18,
    			marginLeft: 19,
    			marginRight: 20,
    			flat: 21
    		});
    	}
    }

    return Barcode;

})));
